#ifndef SMITTEN_CONFIG_HPP
#define SMITTEN_CONFIG_HPP

class ConfigDir {
public:
	std::string name;
	std::string path;

	ConfigDir(const std::string &n, const std::string &p) : name(n), path(p) {
	}
};

class Config {
public:

	typedef enum {
		MEDIA_FIRST = 0,
		MEDIA_MOVIE = MEDIA_FIRST,
		MEDIA_PHOTO,
		MEDIA_MUSIC,
		MEDIA_TEXT,
		MEDIA_LAST,
	} MediaType;

	static Config *get();
	~Config();
	void parse(const std::string &filename);
 
	std::vector<ConfigDir>		m_DirectoryList;
	std::vector<std::string>	m_MediaExtensionList[MEDIA_LAST];
	std::string					m_MediaCommandList[MEDIA_LAST];

	bool		m_AutoPreviewImages;
	bool		m_bFullScreen;
	bool		m_bIgnoreHiddenFiles;
	bool		m_bEnqueueMediaFiles;

	std::string m_ScreensaverDirectory;
	float		m_ScreensaverTimeout;

	float		m_SlideshowTimer;
	float		m_SlideshowTimeOut;

	std::string m_SkinName;
	std::string m_VisualizerName;


protected:
	static Config *m_pSingleton;
	Config();


};

#endif
