#include "smitten.hpp"
#include "fsProcess.hpp"
#include "fsHandler.hpp"
#include "menutypes.hpp"

using namespace std;

void fsHandler::buildMenu(vector<MenuItem *> &menu, vector<fsEntry *> &list) {

	vector<fsEntry *>::const_iterator it = list.begin();
	// Do directories first
	for(;it!=list.end();++it) {
		if ((*it)->isDirectory) {
			menu.push_back(new MediaDirectoryItem((*it)->filename));
		}
	}
	// Now the files
	it = list.begin();
	for(;it!=list.end();++it) {
		if (!(*it)->isDirectory) {
			menu.push_back(MediaFileItem::create((*it)->filename, (*it)->filesize));
		}
	}
}

