#include <windows.h>
#include <tchar.h> 
#include <stdio.h>

#include "smitten.hpp"
#include "fsProcess.hpp"

using namespace std;

bool fsProcess::getDirectory(vector<fsEntry *> &list, const string &directory) {


	if (getCachedDirectory(list, directory)) {
		return true;
	}
	WIN32_FIND_DATAA ffd;

	string szDir = directory;
	szDir += "\\*";

	HANDLE hFind = FindFirstFileA((LPCSTR)szDir.c_str(), &ffd);

	if (INVALID_HANDLE_VALUE == hFind) {
		long dwError = GetLastError();
		if (dwError != ERROR_NO_MORE_FILES) {
		}
		return false;
	}

	bool bIgnoreHiddenFiles = Config::get()->m_bIgnoreHiddenFiles;
  do
   {
	   if (bIgnoreHiddenFiles && ffd.cFileName[0] == '.') {
		   continue;
	   }
	   // Build full name
	   string s = directory;
	   s += "/";
	   s += ffd.cFileName;

      if (ffd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
      {
		  list.push_back(new fsEntry((const char *)s.c_str()));
      }
      else
      {
		  // TODO: use ftLastWriteTime, also
		  list.push_back(new fsEntry((const char *)s.c_str(), ffd.nFileSizeLow));
      }
   }
   while (FindNextFileA(hFind, &ffd) != 0);

   FindClose(hFind);

   return true;
}
