#include "smitten.hpp"
#include "menutypes.hpp"
#include "sgxSystem.hpp"
#include <sstream>

using namespace std;

static int sgxStricmp(std::string &ps1, const char *ps2) {
	return stricmp(ps1.c_str(), ps2);
}

MenuItem *MediaFileItem::create(std::string s, size_t sz) {
	std::string work = s;
	//strupr(work.c_str());
	const char *pExt = strrchr(work.c_str(), '.');
	if (pExt) pExt++;
	int extidx = work.find('.',0);
	string ext = work.substr (extidx+1, work.size()-(extidx+1));

	for(int ext=Config::MEDIA_FIRST;ext<Config::MEDIA_LAST;++ext) {
		vector<string>::iterator it = Config::get()->m_MediaExtensionList[ext].begin();
		vector<string>::iterator end = Config::get()->m_MediaExtensionList[ext].end();
	
		for(;it!=end;++it) {
			if (sgxStricmp(*it, pExt) == 0) {
				switch(ext) {
					case Config::MEDIA_MOVIE:
						return new MediaMovieFileItem(s, sz);
					case Config::MEDIA_MUSIC:
						return new MediaMusicFileItem(s, sz);
					case Config::MEDIA_PHOTO:
						return new MediaImageFileItem(s, sz);
					case Config::MEDIA_TEXT:
						return new MediaTextFileItem(s, sz);
				}
			}
		}
	}

	return new MediaFileItem(s, sz);
}

//
// Standard base
//
MediaFileItem::MediaFileItem(std::string str, size_t sz):  
	MenuItem(str) {

	m_Filepath = str;
	m_FileSize = sz;
}

MediaFileItem::~MediaFileItem() {
	delete m_Preview;
}

void MediaFileItem::getSizeString(std::ostringstream &o) {

	if (m_FileSize < 1024) {
		o << m_FileSize << "bytes";
	} else if (m_FileSize < 1024*1024) {
		o << m_FileSize/1024 << " Kb";
	} else  {
		o << m_FileSize/(1024*1024) << " Mb";
	}
}



bool MediaFileItem::onSelect(MenuList *) {
	// play or preview
	return false;
}

void MediaFileItem::getPreviewText(std::string &text) {
	text = "File of unknown type\n";
}
