#include "smitten.hpp"
#include "SmittenUI.hpp"
#include "menutypes.hpp"
#include <sstream>

bool MediaMovieFileItem::onSelect(MenuList *) {
	MediaHandler *p = SmittenUI::get()->m_pMedia;

	if (p->isPlaying()) {
		// This temporary store is needed in case MediaHandler destroys
		// the current media path after stop() is called.
		bool rt = (p->getCurrentMediaPath() == m_Filepath);
		rt |= p->wereMultipleTracksPlaying();
		p->stop();
		if (rt) {
			return false;
		}
	}

	return SmittenUI::get()->m_pMedia->start(Config::MEDIA_MOVIE, m_Filepath);
}

int MediaMovieFileItem::getIconType() {
	return SmittenSkin::UI_ICON_MOVIE;
}

void MediaMovieFileItem::getPreviewText(std::string &text) {
	std::ostringstream o;
	o << "Movie file\n";
	getSizeString(o);
	text = o.str();
}
