#include "smitten.hpp"
#include "SmittenUI.hpp"
#include "menutypes.hpp"
#include <sstream>


bool MediaMusicFileItem::onSelect(MenuList *) {
	MediaHandler *p = SmittenUI::get()->m_pMedia;

	if (p->isPlaying()) {
		// This temporary store is needed in case MediaHandler destroys
		// the current media path after stop() is called.
		bool rt = (p->getCurrentMediaPath() == m_Filepath);
		rt |= p->wereMultipleTracksPlaying();
		p->stop();
		if (rt) {
			return false;
		}
	}

	if (Config::get()->m_bEnqueueMediaFiles) {
		std::vector<MenuItem *> itemList;
		std::vector<std::string> musicList;
		SmittenUI::get()->m_pMenu->getCurrentAndSubsequentMenuItems(itemList);

		std::vector<MenuItem *>::iterator it = itemList.begin();
		for(;it!=itemList.end();++it) {
			MediaMusicFileItem *pCurrent = dynamic_cast<MediaMusicFileItem *>(*it);
			if (pCurrent) {
				musicList.push_back(pCurrent->m_Filepath);
			}
		}

		return p->start(Config::MEDIA_MUSIC, musicList);
	}

	return p->start(Config::MEDIA_MUSIC, m_Filepath);
}

int MediaMusicFileItem::getIconType() {
	return SmittenSkin::UI_ICON_MUSIC;
}

void MediaMusicFileItem::getPreviewText(std::string &text) {
	std::ostringstream o;
	o << "Music file\n";
	getSizeString(o);
	text = o.str();
}
