#ifndef MENUHANDLER_HPP
#define MENUHANDLER_HPP

class LCARSskin;

class MenuHandler {
public:
	friend SmittenSkin;
	friend LCARSskin;

	MenuHandler();
	~MenuHandler();

	void update(float t);

	void select();

	// These slide graciously by 1
	void moveUp();
	void moveDown();
	void moveLeft();
	void moveRight();
	void rootMenu();

	// These move instantly to n+bySoMany
	void movePageDown(int bySoMany);
	void movePageUp(int bySoMany);
	void moveStartList();
	void moveEndList();
	
	// Abstracted getters
	MenuItem *getCurrentMenuItem();
	unsigned int getCurrentMenuItemIndex();

	MenuList *getCurrentMenuList();
	unsigned int getCurrentMenuListIndex();

	MenuItem *getDirectedMenuItem(int depth);

	void getCurrentAndSubsequentMenuItems(std::vector<MenuItem *> &items);

	virtual void populateMenu(unsigned int menu, MenuItem *pFromMenu=NULL);
	virtual MenuList *populateNextMenu();

	void  clearEntries();

	bool  isMoving();

protected:
	sRect	m_Area;
	std::vector<MenuList *>	m_EntryList;

	unsigned int		m_CurrentList;

	int		m_CurrentScrollX;
	int		m_CurrentScrollY;
	float	m_Scale;

	// These control the scrolling menus. If your skin doesn't need the full
	// extent (of 0 to 1) when moving, then you can force these values to -1/+1
	// and the animation will finish.
	float	m_PositionX, m_PositionY;

};

#endif
