#ifndef MENU_BASE_HPP
#define MENU_BASE_HPP

class MenuList;

class MenuItem {
public:
	MenuItem(std::string s);
	virtual ~MenuItem(){}

	virtual bool onSelect(MenuList *pMenuList=NULL);
	virtual void getType(std::string &type);
	virtual int  getIconType();
	virtual void getPreviewText(std::string &text);
	virtual SmittenImage *getPreviewImage();

	const std::string &visibleName() { return m_Name; }

	SmittenImage		*m_Preview;
protected:
	std::string			m_PreviewText;
	std::string			m_Name;
};


class MenuList {
public:
	MenuList() {}
	~MenuList() {
		clear();
	}
	void clear();

	unsigned int			m_CurrentEntry;
	std::vector<MenuItem *>	m_List;
};

//
// Common MenuItems
//
class MediaDirectoryItem : public MenuItem {
public:
	MediaDirectoryItem(const std::string &path);
	MediaDirectoryItem(const std::string &name, const std::string &path);

	std::string			m_Filepath;

	virtual int  getIconType();
	virtual bool onSelect(MenuList *pMenuList);
};


class GoBackFileItem : public MenuItem {
public:
	GoBackFileItem(std::string s) : MenuItem(s) {}
	virtual bool onSelect(MenuList *pMenuList=NULL);
	virtual int  getIconType();
};

class ExitSmittenItem : public MenuItem {
public:
	ExitSmittenItem(int phase=0);
	virtual bool onSelect(MenuList *pMenuList=NULL);
private:
	int m_Phase;
};

#endif
