#ifndef MENU_TYPES_HPP
#define MENU_TYPES_HPP

/**
Currently supported:
 - Movies
 - Images (jpg/png/bmp)
 - Audio
 - Text files
*/
class MediaFileItem : public MenuItem {
public:
	MediaFileItem(std::string s, size_t sz);
	virtual ~MediaFileItem();
	static MenuItem *create(std::string s, size_t sz);

	std::string			m_Filepath;
	int					m_FileSize;

	void	getSizeString(std::ostringstream &o);

	virtual bool onSelect(MenuList *pMenuList);
	virtual void getPreviewText(std::string &text);
};

class MediaMovieFileItem : public MediaFileItem {
public:
	MediaMovieFileItem(std::string s, size_t sz):MediaFileItem(s,sz){}
	virtual bool onSelect(MenuList *pMenuList);
	virtual int  getIconType();
	virtual void getPreviewText(std::string &text);
};

class MediaMusicFileItem : public MediaFileItem {
public:
	MediaMusicFileItem(std::string s, size_t sz):MediaFileItem(s,sz){}
	virtual bool onSelect(MenuList *pMenuList);
	virtual int  getIconType();
	virtual void getPreviewText(std::string &text);
};

class MediaImageFileItem : public MediaFileItem {
public:
	MediaImageFileItem(std::string s, size_t sz):MediaFileItem(s,sz){m_pFullimage=NULL;}
	virtual ~MediaImageFileItem();
	virtual bool onSelect(MenuList *pMenuList);
	virtual int  getIconType();
	virtual void getPreviewText(std::string &text);

	SmittenImage *m_pFullimage;
};

class MediaTextFileItem : public MediaFileItem {
public:
	MediaTextFileItem(std::string s, size_t sz):MediaFileItem(s,sz){}
	virtual bool onSelect(MenuList *pMenuList);
	virtual int  getIconType();
	virtual void getPreviewText(std::string &text);
};

#endif
