#ifndef SMITTEN_BASE_HPP
#define SMITTEN_BASE_HPP 1

#include <vector>
#include <string>

#include "sgxTextFile.hpp"

class sRect {
public:
	int x, y;
	int w, h;

	sRect() {x=y=0;w=640;h=480;}
	sRect(int x_, int y_, int w_, int h_) { x=x_; y=y_; w=w_; h=h_; }
};

class SmittenImage {
public:
	static SmittenImage *create(void *pPlatformSpecificSurface);
	static SmittenImage *create(const std::string &filename);

	SmittenImage();
	~SmittenImage();

	SmittenImage *resize(int newWidth, int newHeight, bool keepAspect);
	void draw(SmittenImage *pImageSurface, int x, int y);
	void drawArea(SmittenImage *pImageSurface, int x, int y, int sx, int sy, int sx2, int sy2);
	void clip();
	void clip(const sRect &rc);
	void clip(int x, int y, int w, int h);
	void fillRect(const sRect &rect, int r, int g, int b);
	void clear(unsigned int color);
	int getWidth();
	int getHeight();

	SmittenImage *cloneArea(int x, int y, int x2, int y2);

	void setTransparency(int col);

	unsigned int lockPixels();
	unsigned int unlockPixels();
	unsigned int getColor(int x, int y);

private:
	void *m_pData;
	int  m_Locked;
	bool m_bPublicSurface;
};

class SmittenPreviewImage : public SmittenImage {
};

#endif
