#ifndef SMITTEN_UI
#define SMITTEN_UI

class SmittenUI {
public:
	
	typedef enum {
		ModeBrowse,
		ModeSlideshow,
		ModeScreensaver,
		ModeTextview,
		ModeExternalViewer,
		ModeConfig,
		ModeExit,
	} SmittenMode;
	
	typedef enum {
		ActionSelect,
		ActionGoForward,
		ActionGoBack,
		ActionNext,
		ActionPrevious,
		ActionSkipForward,
		ActionSkipBackwards,
		ActionSkipEnd,
		ActionSkipStart,
		ActionRootMenu,
		ActionQuit,
	} SmittenAction;

	int m_Mode;
	//
	// Slideshow
	//
	unsigned int	m_CurrentSlide;
	float			m_CurrentSlideDuration;
	MenuList		*m_pSlideshowDirectory;
	bool			m_LoopSlideshow;
	
	//
	// Text viewer
	//
	sgxTextFile *m_pTextViewerData;
	int m_iCurrentLine;
	int m_iHorizontalOffset;

	MenuHandler		*m_pMenu;
	SmittenSkin		*m_pSkin;
	MediaHandler	*m_pMedia;
	Config			*m_pConfig;

	bool			m_bIsDirty;

	static SmittenUI *get();
	~SmittenUI();
	void create();
	void setScreenImage(SmittenImage *pScreen);
	SmittenImage *getScreenImage();
	//
	void changeMode(int newMode);
	//
	void startSlideshow(MenuList *pMenuList, int firstImage, bool loop);
	void exitSlideshow();
	void nextSlide();
	//
	void startScreensaver();
	//
	void startTextview(MenuItem *pMenuItem);
	void exitTextview();
	//
	void onAction(int action);
	bool update(float t);
	bool draw();
	//
	void buildRootMenu(std::vector<MenuItem *> &menu);

protected:
	static SmittenUI *m_pSingleton;
	
	SmittenUI();

	float nonActionTime;	// for screensaver timeout
	SmittenImage *m_pScreenImage;
};

#endif
