#ifndef SMITTEN_SKIN_HPP
#define SMITTEN_SKIN_HPP

class MenuHandler;
class SmittenFont;

class SmittenSkin {
public:
	SmittenSkin(const std::string &visualizer);

	virtual std::string &getSkinName();

	virtual void create();
	virtual void loadImageSet();

	virtual int  getMenuPageSize();
	virtual int  getTextPageSize();
	virtual int  getWidth();
	virtual int  getHeight();
	virtual int	 getPreviewImageWidth();
	virtual int	 getPreviewImageHeight();
	virtual std::string SmittenSkin::getPath();

	virtual bool wantMousePointer();

	virtual bool update(float t);

	virtual void draw(MenuHandler *pMenu);
	virtual void drawStatic(MenuHandler *pMenu);
	virtual void drawCentreSelection(MenuHandler *pMenu);
	virtual void drawPreview(MenuHandler *pMenu);
	virtual void drawStatusInformation(MenuHandler *pMenu);
	virtual void drawDirectoryPath(MenuHandler *pMenu);
	virtual void drawAlways(MenuHandler *pMenu);
	virtual void drawTextFile(sgxTextFile *pText, int line, int horiz, int x, int y);

	typedef enum {
		UI_ICON_BACK,
		UI_ICON_TEXT,
		UI_ICON_MOVIE, 
		UI_ICON_IMAGE,
		UI_ICON_DIR, 
		UI_ICON_MUSIC,
		UI_ICON_LAST
	} UIIcon; 

protected:
	std::string		m_Visualizer;

	SmittenImage *m_pBackground;
	SmittenImage *m_pBar;
	SmittenImage *m_pDirDivider;

	SmittenImage *m_pIcons[UI_ICON_LAST];

	SmittenFont *m_PreviewFont;
	SmittenFont *m_StatusFont;
	SmittenFont *m_MenuListFont;
	SmittenFont *m_TextBodyFont;

	sRect m_MenuArea;
	sRect m_PreviewArea;
	sRect m_StatusArea;
	sRect m_DirectoryArea;
	virtual void drawMenuItem(MenuItem *pList, int x, int y);
	virtual SmittenImage *getImage(const std::string &name);
};

#endif
